/*CHEABOP PLAYER 0.1*/
/*Copyright 2011 irrlicht project*/
/*This program is Public Domain*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/io.h>


int main(int argc, char **argv)

{


	int ecount, i, j,l,s ;

	FILE* f = fopen("test.song","r");
	if (!f) {
	}

	fscanf(f,"%d",&s);

	fscanf(f,"%d",&l);

	l=l+1;


	int freqa[l];
	int freqb[l];
	int drum[l];


	for (i = 1; i < l && fscanf(f,"%d",&freqa[i]) == 1; ++i);
	for (i = 1; i < l && fscanf(f,"%d",&freqb[i]) == 1; ++i);
	for (i = 1; i < l && fscanf(f,"%d",&drum[i]) == 1; ++i);

	if (!feof(f)) 
	{ /* not all data processed */
    		if (i < l) {
       		 /* error occured (i/o err or bad data) */
    		} else {
        	/* No more memory */
    		}    
	}

	fclose(f);

	printf("\n[cheabop player 0.1]\n\n");


	if( ioperm(0x61, 1, 1) )
	{
		printf("Error ioperm\n");
		exit(0);
	}

	if( ioperm(0x42,2 , 1) )
	{
		printf("Error ioperm\n");
		exit(0);
	}



	for(ecount = 1 ; ecount < l ; ++ecount)
	{

		outb( 0xb6  ,  0x43 );


		if (drum[ecount] == 1) 
		{
		
			for (i = 480 ; i > 60 ; --i)
			{

				int drs = 1193182 / i;
			
				outb( drs & 0xff  ,  0x42 );
				outb( drs >> 8  ,  0x42 );
				usleep(140*s);

			}

			outb( inb(0x61) | 3  ,  0x61 );
			usleep(1000*s);
		
			ecount = ecount + 1;

			} 

		if (drum[ecount] == 2) 
		{
		
			for (j = 1 ; j < 8 ; ++j)
			{

				for (i = 120 ; i > 0 ; --i)
				{

					int drs = 1193182 / ((freqb[i]*16)-3000);
			
					outb( drs & 0xff  ,  0x42 );
					outb( drs >> 8  ,  0x42 );
					usleep(1*s);

				}

				usleep(12);

			}

			outb( inb(0x61) | 3  ,  0x61 );
			usleep(900*s);
		
			ecount = ecount + 1;
		
			}



		int scala = 1193182 / (freqa[ecount]);
		int scalb = 1193182 / freqb[ecount];

		for(i = 0 ; i < s ; ++i )
		{

			outb( scala & 0xff  ,  0x42 );
			outb( scala >> 8  ,  0x42 );
			usleep(22000);
		
			outb( scalb & 0xff  ,  0x42 );
			outb( scalb >> 8  ,  0x42 );
			usleep(10000); 

			outb( scala & 0xff  ,  0x42 );
			outb( scala >> 8  ,  0x42 );
			usleep(12000);
		
			outb( scalb & 0xff  ,  0x42 );
			outb( scalb >> 8  ,  0x42 );
			usleep(20000);

			outb( scala & 0xff  ,  0x42 );
			outb( scala >> 8  ,  0x42 );
			usleep(12000);
		
			outb( scalb & 0xff  ,  0x42 );
			outb( scalb >> 8  ,  0x42 );
			usleep(10000);

		}

		outb( inb(0x61) | 3  ,  0x61 );

	}


	outb( inb(0x61) & ~3  ,  0x61 );

	exit(0);

}
